<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>WarningValue xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/apache/http/impl/client/cache/WarningValue.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.client.cache;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.util.Date;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Matcher;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Pattern;
<a class="jxr_linenumber" name="34" href="#34">34</a>  
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.cookie.DateParseException;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.cookie.DateUtils;
<a class="jxr_linenumber" name="38" href="#38">38</a>  
<a class="jxr_linenumber" name="39" href="#39">39</a>  <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> This class provides for parsing and understanding Warning headers. As</em>
<a class="jxr_linenumber" name="40" href="#40">40</a>  <em class="jxr_javadoccomment"> * the Warning header can be multi-valued, but the values can contain</em>
<a class="jxr_linenumber" name="41" href="#41">41</a>  <em class="jxr_javadoccomment"> * separators like commas inside quoted strings, we cannot use the regular</em>
<a class="jxr_linenumber" name="42" href="#42">42</a>  <em class="jxr_javadoccomment"> * {@link Header#getElements()} call to access the values.</em>
<a class="jxr_linenumber" name="43" href="#43">43</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a> {
<a class="jxr_linenumber" name="45" href="#45">45</a>  
<a class="jxr_linenumber" name="46" href="#46">46</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> offs;
<a class="jxr_linenumber" name="47" href="#47">47</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> init_offs;
<a class="jxr_linenumber" name="48" href="#48">48</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> String src;
<a class="jxr_linenumber" name="49" href="#49">49</a>      <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> warnCode;
<a class="jxr_linenumber" name="50" href="#50">50</a>      <strong class="jxr_keyword">private</strong> String warnAgent;
<a class="jxr_linenumber" name="51" href="#51">51</a>      <strong class="jxr_keyword">private</strong> String warnText;
<a class="jxr_linenumber" name="52" href="#52">52</a>      <strong class="jxr_keyword">private</strong> Date warnDate;
<a class="jxr_linenumber" name="53" href="#53">53</a>  
<a class="jxr_linenumber" name="54" href="#54">54</a>      <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a>(<strong class="jxr_keyword">final</strong> String s) {
<a class="jxr_linenumber" name="55" href="#55">55</a>          <strong class="jxr_keyword">this</strong>(s, 0);
<a class="jxr_linenumber" name="56" href="#56">56</a>      }
<a class="jxr_linenumber" name="57" href="#57">57</a>  
<a class="jxr_linenumber" name="58" href="#58">58</a>      <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a>(<strong class="jxr_keyword">final</strong> String s, <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> offs) {
<a class="jxr_linenumber" name="59" href="#59">59</a>          <strong class="jxr_keyword">this</strong>.offs = <strong class="jxr_keyword">this</strong>.init_offs = offs;
<a class="jxr_linenumber" name="60" href="#60">60</a>          <strong class="jxr_keyword">this</strong>.src = s;
<a class="jxr_linenumber" name="61" href="#61">61</a>          consumeWarnValue();
<a class="jxr_linenumber" name="62" href="#62">62</a>      }
<a class="jxr_linenumber" name="63" href="#63">63</a>  
<a class="jxr_linenumber" name="64" href="#64">64</a>      <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Returns an array of the parseable warning values contained</em>
<a class="jxr_linenumber" name="65" href="#65">65</a>  <em class="jxr_javadoccomment">     * in the given header value, which is assumed to be a</em>
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment">     * Warning header. Improperly formatted warning values will be</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment">     * skipped, in keeping with the philosophy of "ignore what you</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment">     * cannot understand."</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment">     * @param h Warning {@link Header} to parse</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment">     * @return array of &lt;code&gt;WarnValue&lt;/code&gt; objects</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a>[] getWarningValues(<strong class="jxr_keyword">final</strong> Header h) {
<a class="jxr_linenumber" name="73" href="#73">73</a>          <strong class="jxr_keyword">final</strong> List&lt;WarningValue&gt; out = <strong class="jxr_keyword">new</strong> ArrayList&lt;WarningValue&gt;();
<a class="jxr_linenumber" name="74" href="#74">74</a>          <strong class="jxr_keyword">final</strong> String src = h.getValue();
<a class="jxr_linenumber" name="75" href="#75">75</a>          <strong class="jxr_keyword">int</strong> offs = 0;
<a class="jxr_linenumber" name="76" href="#76">76</a>          <strong class="jxr_keyword">while</strong>(offs &lt; src.length()) {
<a class="jxr_linenumber" name="77" href="#77">77</a>              <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="78" href="#78">78</a>                  <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a> wv = <strong class="jxr_keyword">new</strong> <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a>(src, offs);
<a class="jxr_linenumber" name="79" href="#79">79</a>                  out.add(wv);
<a class="jxr_linenumber" name="80" href="#80">80</a>                  offs = wv.offs;
<a class="jxr_linenumber" name="81" href="#81">81</a>              } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException e) {
<a class="jxr_linenumber" name="82" href="#82">82</a>                  <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> nextComma = src.indexOf(',', offs);
<a class="jxr_linenumber" name="83" href="#83">83</a>                  <strong class="jxr_keyword">if</strong> (nextComma == -1) {
<a class="jxr_linenumber" name="84" href="#84">84</a>                      <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="85" href="#85">85</a>                  }
<a class="jxr_linenumber" name="86" href="#86">86</a>                  offs = nextComma + 1;
<a class="jxr_linenumber" name="87" href="#87">87</a>              }
<a class="jxr_linenumber" name="88" href="#88">88</a>          }
<a class="jxr_linenumber" name="89" href="#89">89</a>          <strong class="jxr_keyword">final</strong> <a href="../../../../../../org/apache/http/impl/client/cache/WarningValue.html">WarningValue</a>[] wvs = {};
<a class="jxr_linenumber" name="90" href="#90">90</a>          <strong class="jxr_keyword">return</strong> out.toArray(wvs);
<a class="jxr_linenumber" name="91" href="#91">91</a>      }
<a class="jxr_linenumber" name="92" href="#92">92</a>  
<a class="jxr_linenumber" name="93" href="#93">93</a>      <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_comment">     * LWS            = [CRLF] 1*( SP | HT )</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_comment">     * CRLF           = CR LF</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>  <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>      <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeLinearWhitespace() {
<a class="jxr_linenumber" name="98" href="#98">98</a>          <strong class="jxr_keyword">while</strong>(offs &lt; src.length()) {
<a class="jxr_linenumber" name="99" href="#99">99</a>              <strong class="jxr_keyword">switch</strong>(src.charAt(offs)) {
<a class="jxr_linenumber" name="100" href="#100">100</a>             <strong class="jxr_keyword">case</strong> '\r':
<a class="jxr_linenumber" name="101" href="#101">101</a>                 <strong class="jxr_keyword">if</strong> (offs+2 &gt;= src.length()
<a class="jxr_linenumber" name="102" href="#102">102</a>                     || src.charAt(offs+1) != '\n'
<a class="jxr_linenumber" name="103" href="#103">103</a>                     || (src.charAt(offs+2) != ' '
<a class="jxr_linenumber" name="104" href="#104">104</a>                         &amp;&amp; src.charAt(offs+2) != '\t')) {
<a class="jxr_linenumber" name="105" href="#105">105</a>                     <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="106" href="#106">106</a>                 }
<a class="jxr_linenumber" name="107" href="#107">107</a>                 offs += 2;
<a class="jxr_linenumber" name="108" href="#108">108</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="109" href="#109">109</a>             <strong class="jxr_keyword">case</strong> ' ':
<a class="jxr_linenumber" name="110" href="#110">110</a>             <strong class="jxr_keyword">case</strong> '\t':
<a class="jxr_linenumber" name="111" href="#111">111</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="112" href="#112">112</a>             <strong class="jxr_keyword">default</strong>:
<a class="jxr_linenumber" name="113" href="#113">113</a>                 <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="114" href="#114">114</a>             }
<a class="jxr_linenumber" name="115" href="#115">115</a>             offs++;
<a class="jxr_linenumber" name="116" href="#116">116</a>         }
<a class="jxr_linenumber" name="117" href="#117">117</a>     }
<a class="jxr_linenumber" name="118" href="#118">118</a> 
<a class="jxr_linenumber" name="119" href="#119">119</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="120" href="#120">120</a> <em class="jxr_comment">     * CHAR           = &lt;any US-ASCII character (octets 0 - 127)&gt;</em>
<a class="jxr_linenumber" name="121" href="#121">121</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="122" href="#122">122</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> isChar(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c) {
<a class="jxr_linenumber" name="123" href="#123">123</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> i = c;
<a class="jxr_linenumber" name="124" href="#124">124</a>         <strong class="jxr_keyword">return</strong> (i &gt;= 0 &amp;&amp; i &lt;= 127);
<a class="jxr_linenumber" name="125" href="#125">125</a>     }
<a class="jxr_linenumber" name="126" href="#126">126</a> 
<a class="jxr_linenumber" name="127" href="#127">127</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="128" href="#128">128</a> <em class="jxr_comment">     * CTL            = &lt;any US-ASCII control character</em>
<a class="jxr_linenumber" name="129" href="#129">129</a> <em class="jxr_comment">                        (octets 0 - 31) and DEL (127)&gt;</em>
<a class="jxr_linenumber" name="130" href="#130">130</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="131" href="#131">131</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> isControl(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c) {
<a class="jxr_linenumber" name="132" href="#132">132</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> i = c;
<a class="jxr_linenumber" name="133" href="#133">133</a>         <strong class="jxr_keyword">return</strong> (i == 127 || (i &gt;=0 &amp;&amp; i &lt;= 31));
<a class="jxr_linenumber" name="134" href="#134">134</a>     }
<a class="jxr_linenumber" name="135" href="#135">135</a> 
<a class="jxr_linenumber" name="136" href="#136">136</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="137" href="#137">137</a> <em class="jxr_comment">     * separators     = "(" | ")" | "&lt;" | "&gt;" | "@"</em>
<a class="jxr_linenumber" name="138" href="#138">138</a> <em class="jxr_comment">     *                | "," | ";" | ":" | "\&quot; | &lt;"&gt;</em>
<a class="jxr_linenumber" name="139" href="#139">139</a> <em class="jxr_comment">     *                | "/" | "[" | "]" | "?" | "="</em>
<a class="jxr_linenumber" name="140" href="#140">140</a> <em class="jxr_comment">     *                | "{" | "}" | SP | HT</em>
<a class="jxr_linenumber" name="141" href="#141">141</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="142" href="#142">142</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> isSeparator(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c) {
<a class="jxr_linenumber" name="143" href="#143">143</a>         <strong class="jxr_keyword">return</strong> (c == '(' || c == ')' || c == '&lt;' || c == '&gt;'
<a class="jxr_linenumber" name="144" href="#144">144</a>                 || c == '@' || c == ',' || c == ';' || c == ':'
<a class="jxr_linenumber" name="145" href="#145">145</a>                 || c == '&#92;&#92;' || c == '\&quot;' || c == '/'
<a class="jxr_linenumber" name="146" href="#146">146</a>                 || c == '[' || c == ']' || c == '?' || c == '='
<a class="jxr_linenumber" name="147" href="#147">147</a>                 || c == '{' || c == '}' || c == ' ' || c == '\t');
<a class="jxr_linenumber" name="148" href="#148">148</a>     }
<a class="jxr_linenumber" name="149" href="#149">149</a> 
<a class="jxr_linenumber" name="150" href="#150">150</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="151" href="#151">151</a> <em class="jxr_comment">     * token          = 1*&lt;any CHAR except CTLs or separators&gt;</em>
<a class="jxr_linenumber" name="152" href="#152">152</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="153" href="#153">153</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeToken() {
<a class="jxr_linenumber" name="154" href="#154">154</a>         <strong class="jxr_keyword">if</strong> (!isTokenChar(src.charAt(offs))) {
<a class="jxr_linenumber" name="155" href="#155">155</a>             parseError();
<a class="jxr_linenumber" name="156" href="#156">156</a>         }
<a class="jxr_linenumber" name="157" href="#157">157</a>         <strong class="jxr_keyword">while</strong>(offs &lt; src.length()) {
<a class="jxr_linenumber" name="158" href="#158">158</a>             <strong class="jxr_keyword">if</strong> (!isTokenChar(src.charAt(offs))) {
<a class="jxr_linenumber" name="159" href="#159">159</a>                 <strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="160" href="#160">160</a>             }
<a class="jxr_linenumber" name="161" href="#161">161</a>             offs++;
<a class="jxr_linenumber" name="162" href="#162">162</a>         }
<a class="jxr_linenumber" name="163" href="#163">163</a>     }
<a class="jxr_linenumber" name="164" href="#164">164</a> 
<a class="jxr_linenumber" name="165" href="#165">165</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> isTokenChar(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c) {
<a class="jxr_linenumber" name="166" href="#166">166</a>         <strong class="jxr_keyword">return</strong> (isChar(c) &amp;&amp; !isControl(c) &amp;&amp; !isSeparator(c));
<a class="jxr_linenumber" name="167" href="#167">167</a>     }
<a class="jxr_linenumber" name="168" href="#168">168</a> 
<a class="jxr_linenumber" name="169" href="#169">169</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String TOPLABEL = <span class="jxr_string">"&#92;&#92;p{Alpha}([&#92;&#92;p{Alnum}-]*&#92;&#92;p{Alnum})?"</span>;
<a class="jxr_linenumber" name="170" href="#170">170</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DOMAINLABEL = <span class="jxr_string">"&#92;&#92;p{Alnum}([&#92;&#92;p{Alnum}-]*&#92;&#92;p{Alnum})?"</span>;
<a class="jxr_linenumber" name="171" href="#171">171</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String HOSTNAME = <span class="jxr_string">"("</span> + DOMAINLABEL + <span class="jxr_string">"&#92;&#92;.)*"</span> + TOPLABEL + <span class="jxr_string">"&#92;&#92;.?"</span>;
<a class="jxr_linenumber" name="172" href="#172">172</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String IPV4ADDRESS = <span class="jxr_string">"&#92;&#92;d+&#92;&#92;.&#92;&#92;d+&#92;&#92;.&#92;&#92;d+&#92;&#92;.&#92;&#92;d+"</span>;
<a class="jxr_linenumber" name="173" href="#173">173</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String HOST = <span class="jxr_string">"("</span> + HOSTNAME + <span class="jxr_string">")|("</span> + IPV4ADDRESS + <span class="jxr_string">")"</span>;
<a class="jxr_linenumber" name="174" href="#174">174</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String PORT = <span class="jxr_string">"&#92;&#92;d*"</span>;
<a class="jxr_linenumber" name="175" href="#175">175</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String HOSTPORT = <span class="jxr_string">"("</span> + HOST + <span class="jxr_string">")(&#92;&#92;:"</span> + PORT + <span class="jxr_string">")?"</span>;
<a class="jxr_linenumber" name="176" href="#176">176</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> Pattern HOSTPORT_PATTERN = Pattern.compile(HOSTPORT);
<a class="jxr_linenumber" name="177" href="#177">177</a> 
<a class="jxr_linenumber" name="178" href="#178">178</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeHostPort() {
<a class="jxr_linenumber" name="179" href="#179">179</a>         <strong class="jxr_keyword">final</strong> Matcher m = HOSTPORT_PATTERN.matcher(src.substring(offs));
<a class="jxr_linenumber" name="180" href="#180">180</a>         <strong class="jxr_keyword">if</strong> (!m.find()) {
<a class="jxr_linenumber" name="181" href="#181">181</a>             parseError();
<a class="jxr_linenumber" name="182" href="#182">182</a>         }
<a class="jxr_linenumber" name="183" href="#183">183</a>         <strong class="jxr_keyword">if</strong> (m.start() != 0) {
<a class="jxr_linenumber" name="184" href="#184">184</a>             parseError();
<a class="jxr_linenumber" name="185" href="#185">185</a>         }
<a class="jxr_linenumber" name="186" href="#186">186</a>         offs += m.end();
<a class="jxr_linenumber" name="187" href="#187">187</a>     }
<a class="jxr_linenumber" name="188" href="#188">188</a> 
<a class="jxr_linenumber" name="189" href="#189">189</a> 
<a class="jxr_linenumber" name="190" href="#190">190</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="191" href="#191">191</a> <em class="jxr_comment">     * warn-agent = ( host [ ":" port ] ) | pseudonym</em>
<a class="jxr_linenumber" name="192" href="#192">192</a> <em class="jxr_comment">     * pseudonym         = token</em>
<a class="jxr_linenumber" name="193" href="#193">193</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="194" href="#194">194</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeWarnAgent() {
<a class="jxr_linenumber" name="195" href="#195">195</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> curr_offs = offs;
<a class="jxr_linenumber" name="196" href="#196">196</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="197" href="#197">197</a>             consumeHostPort();
<a class="jxr_linenumber" name="198" href="#198">198</a>             warnAgent = src.substring(curr_offs, offs);
<a class="jxr_linenumber" name="199" href="#199">199</a>             consumeCharacter(' ');
<a class="jxr_linenumber" name="200" href="#200">200</a>             <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="201" href="#201">201</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> IllegalArgumentException e) {
<a class="jxr_linenumber" name="202" href="#202">202</a>             offs = curr_offs;
<a class="jxr_linenumber" name="203" href="#203">203</a>         }
<a class="jxr_linenumber" name="204" href="#204">204</a>         consumeToken();
<a class="jxr_linenumber" name="205" href="#205">205</a>         warnAgent = src.substring(curr_offs, offs);
<a class="jxr_linenumber" name="206" href="#206">206</a>         consumeCharacter(' ');
<a class="jxr_linenumber" name="207" href="#207">207</a>     }
<a class="jxr_linenumber" name="208" href="#208">208</a> 
<a class="jxr_linenumber" name="209" href="#209">209</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="210" href="#210">210</a> <em class="jxr_comment">     * quoted-string  = ( &lt;"&gt; *(qdtext | quoted-pair ) &lt;"&gt; )</em>
<a class="jxr_linenumber" name="211" href="#211">211</a> <em class="jxr_comment">     * qdtext         = &lt;any TEXT except &lt;"&gt;&gt;</em>
<a class="jxr_linenumber" name="212" href="#212">212</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="213" href="#213">213</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeQuotedString() {
<a class="jxr_linenumber" name="214" href="#214">214</a>         <strong class="jxr_keyword">if</strong> (src.charAt(offs) != '\&quot;') {
<a class="jxr_linenumber" name="215" href="#215">215</a>             parseError();
<a class="jxr_linenumber" name="216" href="#216">216</a>         }
<a class="jxr_linenumber" name="217" href="#217">217</a>         offs++;
<a class="jxr_linenumber" name="218" href="#218">218</a>         <strong class="jxr_keyword">boolean</strong> foundEnd = false;
<a class="jxr_linenumber" name="219" href="#219">219</a>         <strong class="jxr_keyword">while</strong>(offs &lt; src.length() &amp;&amp; !foundEnd) {
<a class="jxr_linenumber" name="220" href="#220">220</a>             <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c = src.charAt(offs);
<a class="jxr_linenumber" name="221" href="#221">221</a>             <strong class="jxr_keyword">if</strong> (offs + 1 &lt; src.length() &amp;&amp; c == '&#92;&#92;'
<a class="jxr_linenumber" name="222" href="#222">222</a>                 &amp;&amp; isChar(src.charAt(offs+1))) {
<a class="jxr_linenumber" name="223" href="#223">223</a>                 offs += 2;    <em class="jxr_comment">// consume quoted-pair</em>
<a class="jxr_linenumber" name="224" href="#224">224</a>             } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (c == '\&quot;') {
<a class="jxr_linenumber" name="225" href="#225">225</a>                 foundEnd = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="226" href="#226">226</a>                 offs++;
<a class="jxr_linenumber" name="227" href="#227">227</a>             } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (c != '\&quot;' &amp;&amp; !isControl(c)) {
<a class="jxr_linenumber" name="228" href="#228">228</a>                 offs++;
<a class="jxr_linenumber" name="229" href="#229">229</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="230" href="#230">230</a>                 parseError();
<a class="jxr_linenumber" name="231" href="#231">231</a>             }
<a class="jxr_linenumber" name="232" href="#232">232</a>         }
<a class="jxr_linenumber" name="233" href="#233">233</a>         <strong class="jxr_keyword">if</strong> (!foundEnd) {
<a class="jxr_linenumber" name="234" href="#234">234</a>             parseError();
<a class="jxr_linenumber" name="235" href="#235">235</a>         }
<a class="jxr_linenumber" name="236" href="#236">236</a>     }
<a class="jxr_linenumber" name="237" href="#237">237</a> 
<a class="jxr_linenumber" name="238" href="#238">238</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="239" href="#239">239</a> <em class="jxr_comment">     * warn-text  = quoted-string</em>
<a class="jxr_linenumber" name="240" href="#240">240</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="241" href="#241">241</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeWarnText() {
<a class="jxr_linenumber" name="242" href="#242">242</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> curr = offs;
<a class="jxr_linenumber" name="243" href="#243">243</a>         consumeQuotedString();
<a class="jxr_linenumber" name="244" href="#244">244</a>         warnText = src.substring(curr, offs);
<a class="jxr_linenumber" name="245" href="#245">245</a>     }
<a class="jxr_linenumber" name="246" href="#246">246</a> 
<a class="jxr_linenumber" name="247" href="#247">247</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String MONTH = <span class="jxr_string">"Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec"</span>;
<a class="jxr_linenumber" name="248" href="#248">248</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String WEEKDAY = <span class="jxr_string">"Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday"</span>;
<a class="jxr_linenumber" name="249" href="#249">249</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String WKDAY = <span class="jxr_string">"Mon|Tue|Wed|Thu|Fri|Sat|Sun"</span>;
<a class="jxr_linenumber" name="250" href="#250">250</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String TIME = <span class="jxr_string">"&#92;&#92;d{2}:&#92;&#92;d{2}:&#92;&#92;d{2}"</span>;
<a class="jxr_linenumber" name="251" href="#251">251</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DATE3 = <span class="jxr_string">"("</span> + MONTH + <span class="jxr_string">") ( |&#92;&#92;d)&#92;&#92;d"</span>;
<a class="jxr_linenumber" name="252" href="#252">252</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DATE2 = <span class="jxr_string">"&#92;&#92;d{2}-("</span> + MONTH + <span class="jxr_string">")-&#92;&#92;d{2}"</span>;
<a class="jxr_linenumber" name="253" href="#253">253</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DATE1 = <span class="jxr_string">"&#92;&#92;d{2} ("</span> + MONTH + <span class="jxr_string">") &#92;&#92;d{4}"</span>;
<a class="jxr_linenumber" name="254" href="#254">254</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String ASCTIME_DATE = <span class="jxr_string">"("</span> + WKDAY + <span class="jxr_string">") ("</span> + DATE3 + <span class="jxr_string">") ("</span> + TIME + <span class="jxr_string">") &#92;&#92;d{4}"</span>;
<a class="jxr_linenumber" name="255" href="#255">255</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String RFC850_DATE = <span class="jxr_string">"("</span> + WEEKDAY + <span class="jxr_string">"), ("</span> + DATE2 + <span class="jxr_string">") ("</span> + TIME + <span class="jxr_string">") GMT"</span>;
<a class="jxr_linenumber" name="256" href="#256">256</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String RFC1123_DATE = <span class="jxr_string">"("</span> + WKDAY + <span class="jxr_string">"), ("</span> + DATE1 + <span class="jxr_string">") ("</span> + TIME + <span class="jxr_string">") GMT"</span>;
<a class="jxr_linenumber" name="257" href="#257">257</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String HTTP_DATE = <span class="jxr_string">"("</span> + RFC1123_DATE + <span class="jxr_string">")|("</span> + RFC850_DATE + <span class="jxr_string">")|("</span> + ASCTIME_DATE + <span class="jxr_string">")"</span>;
<a class="jxr_linenumber" name="258" href="#258">258</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String WARN_DATE = <span class="jxr_string">"\&quot;("</span> + HTTP_DATE + <span class="jxr_string">")\&quot;"</span>;
<a class="jxr_linenumber" name="259" href="#259">259</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> Pattern WARN_DATE_PATTERN = Pattern.compile(WARN_DATE);
<a class="jxr_linenumber" name="260" href="#260">260</a> 
<a class="jxr_linenumber" name="261" href="#261">261</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="262" href="#262">262</a> <em class="jxr_comment">     * warn-date  = &lt;"&gt; HTTP-date &lt;"&gt;</em>
<a class="jxr_linenumber" name="263" href="#263">263</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="264" href="#264">264</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeWarnDate() {
<a class="jxr_linenumber" name="265" href="#265">265</a>         <strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">int</strong> curr = offs;
<a class="jxr_linenumber" name="266" href="#266">266</a>         <strong class="jxr_keyword">final</strong> Matcher m = WARN_DATE_PATTERN.matcher(src.substring(offs));
<a class="jxr_linenumber" name="267" href="#267">267</a>         <strong class="jxr_keyword">if</strong> (!m.lookingAt()) {
<a class="jxr_linenumber" name="268" href="#268">268</a>             parseError();
<a class="jxr_linenumber" name="269" href="#269">269</a>         }
<a class="jxr_linenumber" name="270" href="#270">270</a>         offs += m.end();
<a class="jxr_linenumber" name="271" href="#271">271</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="272" href="#272">272</a>             warnDate = DateUtils.parseDate(src.substring(curr+1,offs-1));
<a class="jxr_linenumber" name="273" href="#273">273</a>         } <strong class="jxr_keyword">catch</strong> (<strong class="jxr_keyword">final</strong> DateParseException e) {
<a class="jxr_linenumber" name="274" href="#274">274</a>             <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"couldn't parse a parseable date"</span>);
<a class="jxr_linenumber" name="275" href="#275">275</a>         }
<a class="jxr_linenumber" name="276" href="#276">276</a>     }
<a class="jxr_linenumber" name="277" href="#277">277</a> 
<a class="jxr_linenumber" name="278" href="#278">278</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="279" href="#279">279</a> <em class="jxr_comment">     * warning-value = warn-code SP warn-agent SP warn-text [SP warn-date]</em>
<a class="jxr_linenumber" name="280" href="#280">280</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="281" href="#281">281</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeWarnValue() {
<a class="jxr_linenumber" name="282" href="#282">282</a>         consumeLinearWhitespace();
<a class="jxr_linenumber" name="283" href="#283">283</a>         consumeWarnCode();
<a class="jxr_linenumber" name="284" href="#284">284</a>         consumeWarnAgent();
<a class="jxr_linenumber" name="285" href="#285">285</a>         consumeWarnText();
<a class="jxr_linenumber" name="286" href="#286">286</a>         <strong class="jxr_keyword">if</strong> (offs + 1 &lt; src.length() &amp;&amp; src.charAt(offs) == ' ' &amp;&amp; src.charAt(offs+1) == '\&quot;') {
<a class="jxr_linenumber" name="287" href="#287">287</a>             consumeCharacter(' ');
<a class="jxr_linenumber" name="288" href="#288">288</a>             consumeWarnDate();
<a class="jxr_linenumber" name="289" href="#289">289</a>         }
<a class="jxr_linenumber" name="290" href="#290">290</a>         consumeLinearWhitespace();
<a class="jxr_linenumber" name="291" href="#291">291</a>         <strong class="jxr_keyword">if</strong> (offs != src.length()) {
<a class="jxr_linenumber" name="292" href="#292">292</a>             consumeCharacter(',');
<a class="jxr_linenumber" name="293" href="#293">293</a>         }
<a class="jxr_linenumber" name="294" href="#294">294</a>     }
<a class="jxr_linenumber" name="295" href="#295">295</a> 
<a class="jxr_linenumber" name="296" href="#296">296</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeCharacter(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c) {
<a class="jxr_linenumber" name="297" href="#297">297</a>         <strong class="jxr_keyword">if</strong> (offs + 1 &gt; src.length()
<a class="jxr_linenumber" name="298" href="#298">298</a>             || c != src.charAt(offs)) {
<a class="jxr_linenumber" name="299" href="#299">299</a>             parseError();
<a class="jxr_linenumber" name="300" href="#300">300</a>         }
<a class="jxr_linenumber" name="301" href="#301">301</a>         offs++;
<a class="jxr_linenumber" name="302" href="#302">302</a>     }
<a class="jxr_linenumber" name="303" href="#303">303</a> 
<a class="jxr_linenumber" name="304" href="#304">304</a>     <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="305" href="#305">305</a> <em class="jxr_comment">     * warn-code  = 3DIGIT</em>
<a class="jxr_linenumber" name="306" href="#306">306</a> <em class="jxr_comment">     */</em>
<a class="jxr_linenumber" name="307" href="#307">307</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> consumeWarnCode() {
<a class="jxr_linenumber" name="308" href="#308">308</a>         <strong class="jxr_keyword">if</strong> (offs + 4 &gt; src.length()
<a class="jxr_linenumber" name="309" href="#309">309</a>             || !Character.isDigit(src.charAt(offs))
<a class="jxr_linenumber" name="310" href="#310">310</a>             || !Character.isDigit(src.charAt(offs + 1))
<a class="jxr_linenumber" name="311" href="#311">311</a>             || !Character.isDigit(src.charAt(offs + 2))
<a class="jxr_linenumber" name="312" href="#312">312</a>             || src.charAt(offs + 3) != ' ') {
<a class="jxr_linenumber" name="313" href="#313">313</a>             parseError();
<a class="jxr_linenumber" name="314" href="#314">314</a>         }
<a class="jxr_linenumber" name="315" href="#315">315</a>         warnCode = Integer.parseInt(src.substring(offs,offs+3));
<a class="jxr_linenumber" name="316" href="#316">316</a>         offs += 4;
<a class="jxr_linenumber" name="317" href="#317">317</a>     }
<a class="jxr_linenumber" name="318" href="#318">318</a> 
<a class="jxr_linenumber" name="319" href="#319">319</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> parseError() {
<a class="jxr_linenumber" name="320" href="#320">320</a>         <strong class="jxr_keyword">final</strong> String s = src.substring(init_offs);
<a class="jxr_linenumber" name="321" href="#321">321</a>         <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalArgumentException(<span class="jxr_string">"Bad warn code \&quot;"</span> + s + <span class="jxr_string">"\&quot;"</span>);
<a class="jxr_linenumber" name="322" href="#322">322</a>     }
<a class="jxr_linenumber" name="323" href="#323">323</a> 
<a class="jxr_linenumber" name="324" href="#324">324</a>     <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Returns the 3-digit code associated with this warning.</em>
<a class="jxr_linenumber" name="325" href="#325">325</a> <em class="jxr_javadoccomment">     * @return &lt;code&gt;int&lt;/code&gt;</em>
<a class="jxr_linenumber" name="326" href="#326">326</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="327" href="#327">327</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">int</strong> getWarnCode() { <strong class="jxr_keyword">return</strong> warnCode; }
<a class="jxr_linenumber" name="328" href="#328">328</a> 
<a class="jxr_linenumber" name="329" href="#329">329</a>     <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Returns the "warn-agent" string associated with this warning,</em>
<a class="jxr_linenumber" name="330" href="#330">330</a> <em class="jxr_javadoccomment">     * which is either the name or pseudonym of the server that added</em>
<a class="jxr_linenumber" name="331" href="#331">331</a> <em class="jxr_javadoccomment">     * this particular Warning header.</em>
<a class="jxr_linenumber" name="332" href="#332">332</a> <em class="jxr_javadoccomment">     * @return {@link String}</em>
<a class="jxr_linenumber" name="333" href="#333">333</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="334" href="#334">334</a>     <strong class="jxr_keyword">public</strong> String getWarnAgent() { <strong class="jxr_keyword">return</strong> warnAgent; }
<a class="jxr_linenumber" name="335" href="#335">335</a> 
<a class="jxr_linenumber" name="336" href="#336">336</a>     <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Returns the human-readable warning text for this warning. Note</em>
<a class="jxr_linenumber" name="337" href="#337">337</a> <em class="jxr_javadoccomment">     * that the original quoted-string is returned here, including</em>
<a class="jxr_linenumber" name="338" href="#338">338</a> <em class="jxr_javadoccomment">     * escaping for any contained characters. In other words, if the</em>
<a class="jxr_linenumber" name="339" href="#339">339</a> <em class="jxr_javadoccomment">     * header was:</em>
<a class="jxr_linenumber" name="340" href="#340">340</a> <em class="jxr_javadoccomment">     * &lt;pre&gt;</em>
<a class="jxr_linenumber" name="341" href="#341">341</a> <em class="jxr_javadoccomment">     *   Warning: 110 fred "Response is stale"</em>
<a class="jxr_linenumber" name="342" href="#342">342</a> <em class="jxr_javadoccomment">     * &lt;/pre&gt;</em>
<a class="jxr_linenumber" name="343" href="#343">343</a> <em class="jxr_javadoccomment">     * then this method will return &lt;code&gt;"\&quot;Response is stale\&quot;"&lt;/code&gt;</em>
<a class="jxr_linenumber" name="344" href="#344">344</a> <em class="jxr_javadoccomment">     * (surrounding quotes included).</em>
<a class="jxr_linenumber" name="345" href="#345">345</a> <em class="jxr_javadoccomment">     * @return {@link String}</em>
<a class="jxr_linenumber" name="346" href="#346">346</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="347" href="#347">347</a>     <strong class="jxr_keyword">public</strong> String getWarnText() { <strong class="jxr_keyword">return</strong> warnText; }
<a class="jxr_linenumber" name="348" href="#348">348</a> 
<a class="jxr_linenumber" name="349" href="#349">349</a>     <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Returns the date and time when this warning was added, or</em>
<a class="jxr_linenumber" name="350" href="#350">350</a> <em class="jxr_javadoccomment">     * &lt;code&gt;null&lt;/code&gt; if a warning date was not supplied in the</em>
<a class="jxr_linenumber" name="351" href="#351">351</a> <em class="jxr_javadoccomment">     * header.</em>
<a class="jxr_linenumber" name="352" href="#352">352</a> <em class="jxr_javadoccomment">     * @return {@link Date}</em>
<a class="jxr_linenumber" name="353" href="#353">353</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="354" href="#354">354</a>     <strong class="jxr_keyword">public</strong> Date getWarnDate() { <strong class="jxr_keyword">return</strong> warnDate; }
<a class="jxr_linenumber" name="355" href="#355">355</a> 
<a class="jxr_linenumber" name="356" href="#356">356</a>     <em class="jxr_javadoccomment">/**</em><em class="jxr_javadoccomment"> Formats a &lt;code&gt;WarningValue&lt;/code&gt; as a {@link String}</em>
<a class="jxr_linenumber" name="357" href="#357">357</a> <em class="jxr_javadoccomment">     * suitable for including in a header. For example, you can:</em>
<a class="jxr_linenumber" name="358" href="#358">358</a> <em class="jxr_javadoccomment">     * &lt;pre&gt;</em>
<a class="jxr_linenumber" name="359" href="#359">359</a> <em class="jxr_javadoccomment">     *   WarningValue wv = ...;</em>
<a class="jxr_linenumber" name="360" href="#360">360</a> <em class="jxr_javadoccomment">     *   HttpResponse resp = ...;</em>
<a class="jxr_linenumber" name="361" href="#361">361</a> <em class="jxr_javadoccomment">     *   resp.addHeader("Warning", wv.toString());</em>
<a class="jxr_linenumber" name="362" href="#362">362</a> <em class="jxr_javadoccomment">     * &lt;/pre&gt;</em>
<a class="jxr_linenumber" name="363" href="#363">363</a> <em class="jxr_javadoccomment">     * @return {@link String}</em>
<a class="jxr_linenumber" name="364" href="#364">364</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="365" href="#365">365</a>     @Override
<a class="jxr_linenumber" name="366" href="#366">366</a>     <strong class="jxr_keyword">public</strong> String toString() {
<a class="jxr_linenumber" name="367" href="#367">367</a>         <strong class="jxr_keyword">if</strong> (warnDate != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="368" href="#368">368</a>             <strong class="jxr_keyword">return</strong> String.format(<span class="jxr_string">"%d %s %s \&quot;%s\&quot;"</span>, warnCode,
<a class="jxr_linenumber" name="369" href="#369">369</a>                     warnAgent, warnText, DateUtils.formatDate(warnDate));
<a class="jxr_linenumber" name="370" href="#370">370</a>         } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="371" href="#371">371</a>             <strong class="jxr_keyword">return</strong> String.format(<span class="jxr_string">"%d %s %s"</span>, warnCode, warnAgent, warnText);
<a class="jxr_linenumber" name="372" href="#372">372</a>         }
<a class="jxr_linenumber" name="373" href="#373">373</a>     }
<a class="jxr_linenumber" name="374" href="#374">374</a> 
<a class="jxr_linenumber" name="375" href="#375">375</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

